function  [ksi_TE, psi_TE, ksi_TM, psi_TM] = mk_psi( M, N, P, Q, a, A, b, B)
iM  = M + 1;
iN  = N + 1;
ksi_TE = zeros( 2, iM+M, iN+N, P+1, Q+1);           % spectral domain weighting functions
psi_TE = ksi_TE;                                    % spectral domain basis functions
ksi_TM = ksi_TE;
psi_TM = ksi_TE;

for m=-M:M
  for n=-N:N
    for p=0:P
      for q=0:Q
        xkf1 = f1( p, a, m, A);
        xkf2 = f2( q, b, n, B);
        ykf1 = f1( q, b, n, B);
        ykf2 = f2( p, a, m, A);
        ksi_x  = xkf1 * xkf2;
        ksi_y  = ykf1 * ykf2;
        ksi_TE(:,iM+m,iN+n,p+1,q+1) = [ + (p*pi/a)*ksi_x;  + (q*pi/b)*ksi_y];
        psi_TE = conj(ksi_TE);
        ksi_TM(:,iM+m,iN+n,p+1,q+1) = [ + (q*pi/b)*ksi_x;  - (p*pi/a)*ksi_y];
        psi_TM = conj(ksi_TM);
      end
    end
  end
end
psi_TE = psi_TE /(A*B);
psi_TM = psi_TM /(A*B);

function kf1 = f1( p, a, m, A)
pls = (pi/2) * (p + 2*m*a/A);
mns = (pi/2) * (p - 2*m*a/A);
kf1 = -j * (a/2) * ( sinc( pls)*exp( +j*pls) - sinc( mns)*exp( -j*mns));


function kf2 = f2( p, a, m, A)
pls = (pi/2) * (p + 2*m*a/A);
mns = (pi/2) * (p - 2*m*a/A);
kf2 = + (a/2) * ( sinc( pls)*exp( +j*pls) + sinc( mns)*exp( -j*mns));

